"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.check = check;

var _globby = _interopRequireDefault(require("globby"));

var path = _interopRequireWildcard(require("path"));

var _getModularRoot = _interopRequireDefault(require("../utils/getModularRoot"));

var _getWorkspaceInfo = _interopRequireDefault(require("../utils/getWorkspaceInfo"));

var logger = _interopRequireWildcard(require("../utils/logger"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

async function check() {
  let valid = true;
  const workspace = await (0, _getWorkspaceInfo.default)();
  const modularRoot = (0, _getModularRoot.default)();
  /**
   * Validate the the worktree is valid against the globby of pacakge.json files which are found in the
   * current working directory. They should be the same but you never know...
   */

  const workspaceLocations = (await (0, _globby.default)(['packages/**/package.json', '!**/node_modules/**'], {
    onlyFiles: true,
    cwd: modularRoot
  })).map(l => path.dirname(l));
  Object.entries(workspace).forEach(([packageName, w]) => {
    const workspaceLocation = w.location;
    const overlapping = workspaceLocations.filter(otherWorkspaceLocation => {
      // obviously workspaces which are the same can't be overlapping
      const relative = path.relative(workspaceLocation, otherWorkspaceLocation);
      return relative && !relative.startsWith('..') && !path.isAbsolute(relative);
    });

    if (overlapping.length) {
      logger.error(`Found ${workspaceLocation} which is an overlapping workspace with ${overlapping.join(', ')} in your current worktree`);
      valid = false;
    } else {
      logger.debug(`${packageName} has valid dependencies`);
    }
  });
  return valid;
}
//# sourceMappingURL=verifyWorkspaceStructure.js.map