"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _chalk = _interopRequireDefault(require("chalk"));

var path = _interopRequireWildcard(require("path"));

var _getModularRoot = _interopRequireDefault(require("../../utils/getModularRoot"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createPlugin(paths) {
  return {
    name: 'ModuleScopePlugin',

    setup(build) {
      const appSrc = paths.appSrc;
      const relativeAppSrc = path.relative((0, _getModularRoot.default)(), appSrc);
      build.onResolve({
        filter: /.*/,
        namespace: 'file'
      }, args => {
        if (!args.importer) {
          return;
        }

        if ( // If this resolves to a node_module, we don't care what happens next
        args.importer.indexOf('/node_modules/') !== -1 || args.importer.indexOf('\\node_modules\\') !== -1) {
          return;
        }

        const relative = path.relative(appSrc, args.importer);

        if ( // If it's not in one of our app src or a subdirectory, not our request!
        relative.startsWith('../') || relative.startsWith('..\\')) {
          return;
        }

        const requestFullPath = path.resolve(path.dirname(args.importer), args.path); // Find path from src to the requested file
        // Error if in a parent directory of all given appSrcs

        const requestRelative = path.relative(appSrc, requestFullPath);

        if (requestRelative.startsWith('../') || requestRelative.startsWith('..\\')) {
          return {
            errors: [{
              pluginName: 'ModuleScopePlugin',
              text: `You attempted to import ${_chalk.default.cyan(args.path)} which falls outside of the project ${_chalk.default.cyan(relativeAppSrc)} directory. 
Relative imports outside of ${_chalk.default.cyan(relativeAppSrc)} are not supported.
You can either move it inside ${_chalk.default.cyan(relativeAppSrc)}, or move it to another ${_chalk.default.cyan('modular')} package.`
            }]
          };
        } else {
          return;
        }
      });
    }

  };
}

var _default = createPlugin;
exports.default = _default;
//# sourceMappingURL=moduleScopePlugin.js.map