"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _stream = require("stream");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class LineFilterOutStream extends _stream.Transform {
  // A stream transform to filter out lines that pass the regexp test
  constructor(pattern) {
    super();

    _defineProperty(this, "buffer", '');

    _defineProperty(this, "pattern", void 0);

    this.pattern = pattern;
  }

  _transform(chunk, encoding, callback) {
    var _lines$pop;

    const data = String(chunk);
    const lines = data.split('\n'); // Handle last line which is probably incomplete

    lines[0] = this.buffer + lines[0];
    this.buffer = (_lines$pop = lines.pop()) !== null && _lines$pop !== void 0 ? _lines$pop : '';
    const output = lines.reduce((acc, line) => {
      if (!this.pattern.test(line)) {
        acc += `${line}\n`;
      }

      return acc;
    }, '');
    this.push(output);
    callback();
  }

}

exports.default = LineFilterOutStream;
//# sourceMappingURL=LineFilterOutStream.js.map